/* LICENSE:
Copyright (c) Members of the EGEE Collaboration. 2010.
See http://www.eu-egee.org/partners/ for details on the copyright
holders.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

   http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
implied.
See the License for the specific language governing permissions and
limitations under the License.

END LICENSE */

#include <getopt.h>
#include <iostream>
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <istream>
#include <fstream>
#include <sys/types.h>
#include "glite/ce/cream-client-api-c/certUtil.h"
#include "glite/ce/cream-client-api-c/CreamProxyFactory.h"
#include "glite/ce/cream-client-api-c/CreamProxy_Impl.h"
#include "glite/ce/cream-client-api-c/ConfigurationManager.h"
#include "glite/ce/cream-client-api-c/creamApiLogger.h"
#include "glite/ce/cream-client-api-c/VOMSWrapper.h"
#include "glite/ce/cream-client-api-c/CEUrl.h"
#include "hmessages.h"
#include "util/cliUtils.h"
#include "boost/algorithm/string.hpp"
#include "boost/format.hpp"


using namespace std;
using namespace glite::ce::cream_client_api::soap_proxy;
using namespace glite::ce::cream_client_api::util;
using namespace glite::ce::cream_client_api;

Namespace namespaces[] = {};

void printhelp(void) ;

int main(int argc, char *argv[]) {

  string jobID;
  string endpoint;
  bool debug = false;
  bool hostset=false;
  char c;
  int option_index = 0;
  string logfile;
  bool redir_out = false;
//old code  bool joblist_from_file=false;
//old code  string joblist_file = "";
  bool WRITE_LOG_ON_FILE = true;
  bool nomsg = false;
  bool noint = false;
  //bool all = false;
//old code vector<string> all_jobids_to_renew, all_jobids_to_actually_renew;
  vector<string> all_delegationids_to_renew;
//old code map <string, vector<string> > url_jobids;
//old code bool renew_all_jobs_from_file = false;
  string    user_conf_file = "";
  string certfile;
  string proxyfile;
  string DID = "";
  bool specified_proxyfile=false;
//old code bool specified_did=false;
  creamApiLogger* logger_instance = creamApiLogger::instance();
  log4cpp::Category* log_dev = logger_instance->getLogger();

  // Initialize the logger
  log_dev->setPriority( log4cpp::Priority::NOTICE );
  logger_instance->setLogfileEnabled( WRITE_LOG_ON_FILE );

  //old code all_jobids_to_renew.reserve(100);
  //old code all_jobids_to_actually_renew.reserve(100);
  all_delegationids_to_renew.reserve(100);

  int timeout = 30;

  bool verify_ac_sign = true;

  while(1) {
    static struct option long_options[] = {
      {"help", 0, 0, 'h'},
      {"debug", 0, 0, 'd'},
      {"version", 0, 0, 'v'},
      {"endpoint", 1, 0, 'e'},
      {"logfile", 1, 0, 'l'},
      {"input", 1, 0, 'i'},
      {"noint", 0, 0, 'N'},
      //{"all", 0, 0, 'a'},
      {"nomsg", 0, 0, 'n'},
      {"conf", 1, 0, 'c'},
      {"proxyfile", 1, 0, 'p'},
      {"delegationId", 1,0,'D'},
      {"timeout", 1, 0, 't'},
      {"donot-verify-ac-sign", 0, 0, 'A'},
      {0, 0, 0, 0}
    };
    c = getopt_long(argc, argv, "p:l:Anhdve:i:Nc:D:t:", long_options, &option_index);
    if ( c == -1 )
      break;

    switch(c) {
    case 'A':
      verify_ac_sign = false;
      break;  
    case 'p':
      proxyfile = string(optarg);
      specified_proxyfile = true;
      break;
//     case 'a':
//       all=true;
//       break;
    case 'N':
      noint=true;
      break;
    case 'v':
      help_messages::printver();
      exit(0);
      break;
    case 'h':
      printhelp();
      exit(0);
      break;
    case 'd':
      debug=true;
      log_dev->setPriority( log4cpp::Priority::INFO );
      break;
    case 'l':
      redir_out = true;
      logfile = string(optarg);
      break;
    case 'n':
      nomsg = true;
      log_dev->setPriority( log4cpp::Priority::ERROR );
      break;
// ---old code
//    case 'i':
//      joblist_from_file=true;
//      joblist_file = string(optarg);
//      break;
    case 'e':
      endpoint = string(optarg);
      hostset=true;
      break;
    case 'c':
      user_conf_file = string(optarg);
      break;
// ---old code
//    case 'D':
//      DID = string(optarg);
//      specified_did=true;
//      break;
    case 't':
      timeout = atoi(optarg);
      break;
     default:
      cerr << "Type " << argv[0] << " -h for an help"<<endl;
      exit(1);

    }
  }

  if(nomsg && debug) {
    // ERROR
    logger_instance->log(log4cpp::Priority::ERROR, "Cannot specify both --debug and --nomsg options. Stop.", false, true, true);
    exit(1);
  }

/* ---- old code
  if(!specified_did)
  {
    logger_instance->log(log4cpp::Priority::ERROR, "Must specify the delegation ID with --delegationId|-D switch.", false, true, true);
    exit(1);
  }
*/
/*---- old code Comment to port the code to new client
  CreamProxy *initSoap;
  string VO = "";
  try {
    initSoap = new CreamProxy(false);
    initSoap->printDebug(debug);
    if(!specified_proxyfile)
      certfile = cliUtils::getProxyCertificateFile();
    else
      certfile = proxyfile;
    if(debug)
      logger_instance->log(log4cpp::Priority::INFO, string("Using certificate proxy file [")
			   + certfile + "]", true, WRITE_LOG_ON_FILE, true);
    VO = initSoap->Authenticate(certfile);
*/
    /**
     * if all is ON 'all_jobids_to_renew' is an empty vector
     */
/*
  } catch(soap_ex& s) {
    logger_instance->log(log4cpp::Priority::INFO, s.what(), true, WRITE_LOG_ON_FILE, true);
    exit(1);
  } catch(auth_ex& auth) {
    logger_instance->log(log4cpp::Priority::ERROR, auth.what(), true, WRITE_LOG_ON_FILE, true);
    exit(1);
  }
*/
  string VO = "";

  if(!specified_proxyfile) {
    try {
      certfile = cliUtils::getProxyCertificateFile();
    } catch(exception& ex) {
      logger_instance->log(log4cpp::Priority::FATAL, ex.what(), true, true, true);
      exit(1);
    }
  } else
    certfile = proxyfile;

  log_dev->info( "Using certificate proxy file [%s]", certfile.c_str() );

  VOMSWrapper V( certfile, verify_ac_sign );
    if( !V.IsValid( ) ) {
      
        logger_instance->log(log4cpp::Priority::FATAL,
                             string("Problems with proxyfile [")+certfile+"]: "+
                             V.getErrorMessage(), true, true, true);
	exit(1);
      
    }
//  else
//       logger_instance->log(log4cpp::Priority::ERROR,
//                            "Error while reading proxyfile ["+certfile+"]: "+
//                            V.getErrorMessage(), true, true, true);
//         exit(1);
//     }

//     long int leftcert = V.getProxyTimeEnd( ) - time( NULL );

//     if(leftcert <= 0) {
//       log_dev->fatal( "Proxy certificate is expired. Please Check it." );
//       exit(1);
//     }

    VO = V.getVOName( );
  
  /**
   * Handle the load of configurations
   */
  vector<string> confiles;
  try {
    confiles = cliUtils::getConfigurationFiles(VO,
					       user_conf_file, 
					       DEFAULT_CONF_FILE);
  } catch(no_user_confile_ex& ex) {
    logger_instance->log(log4cpp::Priority::ERROR, ex.what(), true, WRITE_LOG_ON_FILE, true);
    exit(1);
  }

  if(debug) {
    for(vector<string>::const_iterator fit = confiles.begin();
        fit != confiles.end();
        fit++) //unsigned int j=0; j<confiles.size(); j++)
      logger_instance->log(log4cpp::Priority::INFO, 
			   string("Loading configurations from [")
			   + *fit +"]...", true, WRITE_LOG_ON_FILE, true);
  }

  ConfigurationManager confMgr(ConfigurationManager::classad);
  try { confMgr.load(confiles); }
  catch(file_ex& ex) {
    if(debug)
    logger_instance->log(log4cpp::Priority::WARN, 
			   string(ex.what())+". Using built-in configuration",
			   true,WRITE_LOG_ON_FILE,!nomsg);
  }

  if(debug || redir_out) {
    if(!redir_out)
      logfile = logger_instance->getLogFileName(confMgr.getProperty("PROXYRENEW_LOG_DIR", DEFAULT_LOG_DIR).c_str(), "glite-ce-proxy-renew");
    cliUtils::mkdir(cliUtils::getPath(logfile));
    logger_instance->setLogFile(logfile.c_str());
  }
  if(debug) {
    string os = string("Logfile is [") + logfile + "]";

    logger_instance->log(log4cpp::Priority::INFO, os, false, false, !nomsg);
  }


//   if( (all && joblist_from_file) || (argv[optind]!=NULL && all)){
//     // ERROR
//     logger_instance->log(log4cpp::Priority::ERROR, "--all and --input or --all and specification of JobID(s) as argument are exclusive. Stop.", true, WRITE_LOG_ON_FILE, true);
//     exit(1);
//   }

  if( argv[optind]==NULL ) {  //old code && (!joblist_from_file) ) {
    //ERROR
 //old code logger_instance->log(log4cpp::Priority::ERROR,"No Job ID nor JobList file have been specified in the command line arguments. Stop.", false, WRITE_LOG_ON_FILE, true);
    logger_instance->log(log4cpp::Priority::ERROR,"No Delegation ID has been specified in the command line arguments. Stop.", false, WRITE_LOG_ON_FILE, true);
    exit(1);
  } 

//   if(all && !hostset) {
//     // ERROR
//     logger_instance->log(log4cpp::Priority::ERROR, "Option --all requires the specification of the endpoint (option --endpoint) to contact. Stop.", true, WRITE_LOG_ON_FILE, true);
//     exit(1);
//   }
  
  if(debug) {
    logger_instance->log(log4cpp::Priority::INFO, "*************************************", false, WRITE_LOG_ON_FILE, !nomsg);
    logger_instance->log(log4cpp::Priority::INFO, help_messages::getStartMessage().c_str(), false, WRITE_LOG_ON_FILE, !nomsg);
  }

  if(!hostset) {
    logger_instance->log(log4cpp::Priority::ERROR,"Please specify the endpoint with '--endpoint|-e' switch. Stop",  false, WRITE_LOG_ON_FILE, true);
    exit(1);
  }


  if(hostset) {

    if( !cliUtils::checkEndpointFormat( endpoint ) )
    {
      logger_instance->log(log4cpp::Priority::ERROR, "Endpoint not specified in the right format: should be <host>[:tcpport]. Stop.",  true, WRITE_LOG_ON_FILE, true);
      exit(1);
    }
  
  }
//     boost::regex pattern( "^[^:]+(:[0-9]{1,5})?\\b" );
//     boost::smatch what;
//     if( !boost::regex_match( endpoint, what, pattern ) ) {
//     //if(!string_manipulation::matches(endpoint,"^[^:]+(:[0-9]{1,5})?\\b")) {
//       logger_instance->log(log4cpp::Priority::ERROR,"Specified endpoint has wrong format. Must be <host>:<tcp_port> (tcp_port is a number of 5 digit max length). Stop", true, WRITE_LOG_ON_FILE,true);
//       exit(1);
//     }


  /**
   *
   * old code replaced with the new vector of delegation id
   */
//  while(argv[optind]!=NULL) {
//    all_jobids_to_renew.push_back(string(argv[optind]));
//    optind++;
//  }
  
  if(argv[optind]==NULL) {
    log_dev->error( "delegationID not specified in the command line arguments. Stop." );
    return(1);
  } else {
      while(argv[optind]!=NULL) {
        all_delegationids_to_renew.push_back(string(argv[optind]));
        optind++;
      }
  }


  if( !cliUtils::containsTCPPort(endpoint) ) {
    endpoint += ":" + confMgr.getProperty("DEFAULT_CREAM_TCPPORT", "8443");
  }


  /*
   *
   * Gets job IDs from input file and asks the user
   *
   */

    string serviceAddress =
      confMgr.getProperty("CREAMDELEGATION_URL_PREFIX", DEFAULT_PROTO)
      + endpoint+"/"
      + confMgr.getProperty("CREAMDELEGATION_URL_POSTFIX", DEFAULT_CEURLDELEGATION_POSTFIX);
    log_dev->info( "Delegating proxy on service [%s] ",
                   serviceAddress.c_str() );
/**
  if(debug) {
    string serviceAddressLog = "Service address=[" + serviceAddress + "]";
    logger_instance->log(log4cpp::Priority::INFO, serviceAddressLog.c_str(), false, WRITE_LOG_ON_FILE, !nomsg);
  }
*/
/*--- commet old code using the jobid file list
  unsigned int jcounter = 0;
  vector<string> jobnumbers_to_renew;
  jobnumbers_to_renew.reserve(100);
  if(joblist_from_file) {
    bool isjoblist = true;
    int f;
    if(debug) {
      string os = string("Getting job list from file [") + joblist_file + "]";
      logger_instance->log(log4cpp::Priority::INFO, os, true, WRITE_LOG_ON_FILE, !nomsg);
    }
    
    if((f=open(joblist_file.c_str(), O_RDONLY))==-1) {
      int saveerr = errno;
      string os = string("Error accessing file [") + joblist_file + "]: " + strerror(saveerr) + ". Stop.";
      logger_instance->log(log4cpp::Priority::ERROR, os, true, WRITE_LOG_ON_FILE, true);
      exit(1);
    }
    close(f);
    
    isjoblist = cliUtils::isACreamJobListFile(joblist_file.c_str());
    if(!isjoblist) {
      string os = string("File [") + joblist_file + "] is not a CREAM job list file. Stop.";
      logger_instance->log(log4cpp::Priority::ERROR, os, true,WRITE_LOG_ON_FILE, true);
      exit(1);
    }
    cliUtils::getJobIDFromFile(all_jobids_to_renew, joblist_file.c_str());
    
    if(!noint) {
      string os = string("\nFound the following jobs in [") + joblist_file + "]: ";
      logger_instance->log(log4cpp::Priority::INFO, os, false, false, true);
    }
    string whichone = "";
    if(!noint) {
      printf("\n");
      for(vector<string>::const_iterator jit = all_jobids_to_renew.begin();
          jit != all_jobids_to_renew.end();
          jit++) {
        printf("%s\n", (boost::str( boost::format("%d") % jcounter++) + ". " + *jit).c_str());
      }
      printf("a. Renew all jobs\n");
      printf("q. Quit\n");
      printf("\nYour choice ? (multiple choices separated by ',') ");
      cin >> (string&)whichone;
      if( whichone == "q" ) {
        printf("Renew aborted. Bye.\n");
        exit(0);
      }
    } else whichone = "a";
    if( whichone == "a" ) renew_all_jobs_from_file=true;
    boost::split(jobnumbers_to_renew, whichone, boost::is_any_of(","));
  }
*/
  /**
   * Add the tcpport if not specified on the command line
   */
//   boost::regex pattern( "^\\w+(:\\d+)" );
//   boost::smatch _what;
//   //printf("endpoint=[%s]\n", endpoint.c_str());
//   if( !boost::regex_match( endpoint, _what, pattern ) ) {
//  if(!cliUtils::containsTCPPort( endpoint )) {
//    endpoint = endpoint + ":" + confMgr.getProperty("DEFAULT_CREAM_TCPPORT", "8443");
    //printf("endpoint=[%s]\n", endpoint.c_str());
//  }
  //  if(!all) {
    /**
     *
     * Asks confirmation about renew of selected job IDs
     *
     */
/* --- old code
    char confirm;
    if(!noint) {
      printf("\nAre you sure you want to renew the proxy of the specified job(s) [y/n]: ");
      cin >> confirm;
    } else confirm ='y';

    if(confirm != 'y') {
      printf("Renew aborted. Bye.\n");
      exit(0);
    }
*/
    /**
     *
     * Filters out the job IDs the user didn't select
     *
     */
/* ---old code
    for(jcounter=0; jcounter<all_jobids_to_renew.size(); jcounter++) {
      if(joblist_from_file) {
        if(!renew_all_jobs_from_file) {
	  bool isthere = false;
	  for(
	      vector<string>::iterator it = jobnumbers_to_renew.begin();
	      it!=jobnumbers_to_renew.end();
	      it++)
	    if( jcounter == atoi( (*it).c_str()) ) { isthere = true; break; }
	  if(!isthere) continue;
        }
	if(debug)
	  logger_instance->log(log4cpp::Priority::INFO, string("Will renew job [")+all_jobids_to_renew.at(jcounter)+"]", true, WRITE_LOG_ON_FILE, true);
	all_jobids_to_actually_renew.push_back(all_jobids_to_renew.at(jcounter));
      }
      else all_jobids_to_actually_renew.push_back(all_jobids_to_renew.at(jcounter));
    }
*/
    /**
     *
     * Create an hash map CEId -> JobIDs
     *
     */
/* ---old code Comment the map part 
    vector<string> pieces;
    pieces.reserve(10);

    for(vector<string>::const_iterator jit = all_jobids_to_actually_renew.begin();
	jit != all_jobids_to_actually_renew.end();
	jit++) {
      if(hostset) {
	string tmp = confMgr.getProperty("CREAM_URL_PREFIX", DEFAULT_PROTO)+
	  endpoint+"/"+confMgr.getProperty("CREAM_URL_POSTFIX", DEFAULT_CEURL_POSTFIX);
        url_jobids[tmp].push_back( *jit );
      }
      else {
        pieces.clear();
        try { CEUrl::parseJobID( *jit, pieces, confMgr.getProperty("DEFAULT_CREAM_TCPPORT", "8443")); }
        catch(CEUrl::ceid_syntax_ex& ex) {
          logger_instance->log(log4cpp::Priority::ERROR, ex.what(), true, WRITE_LOG_ON_FILE, true);
          logger_instance->log(log4cpp::Priority::ERROR,"This JobID doesn't contain the CREAM service address. Skipping it...",true, WRITE_LOG_ON_FILE, true);
	  continue;
        }
	string tmp = confMgr.getProperty("CREAM_URL_PREFIX", DEFAULT_PROTO)+
	  pieces[1]+":"+pieces[2]+"/"+
	  confMgr.getProperty("CREAM_URL_POSTFIX", DEFAULT_CEURL_POSTFIX);
	 url_jobids[tmp].push_back( *jit );
      }
    }
*/
//   } else {
//     serviceAddress = confMgr.getProperty("CREAM_URL_PREFIX", DEFAULT_PROTO);
//     serviceAddress = serviceAddress + endpoint + "/" + confMgr.getProperty("CREAM_URL_POSTFIX", DEFAULT_CEURL_POSTFIX);
//   }



  try {
    for( vector<string>::iterator it = all_delegationids_to_renew.begin();
         it!=all_delegationids_to_renew.end();
         it++ ) {
     
      AbsCreamProxy* creamClient = CreamProxyFactory::make_CreamProxy_ProxyRenew(*it, timeout );
      if(!creamClient)
      {
        log_dev->fatal( "CreamProxy creation FAILED!! Stop!");
        return(1);
      }

      boost::scoped_ptr< AbsCreamProxy > tmpRegisterClient;
      tmpRegisterClient.reset( creamClient );

      creamClient->setCredential( certfile );
      creamClient->execute( serviceAddress );

      log_dev->notice( "Proxy with delegation id [%s] succesfully renewed to endpoint [%s]",
                     (*it).c_str(), serviceAddress.c_str() );
     
    } 
  } catch(BaseException& ex ) {
      log_dev->log(log4cpp::Priority::ERROR, ex.what(), true, WRITE_LOG_ON_FILE, true);
      exit(1);
  } catch(exception& s) {
    logger_instance->log(log4cpp::Priority::ERROR, s.what(), true, WRITE_LOG_ON_FILE, true );
    exit(1);
  }

/* --- old code
  try {
//     if(all && !noint) {
//       char confirm;
//       printf("\nGoing to renew all job from CE [%s]. Do you want to proceed [y/n]? ",
// 	     serviceAddress.c_str());
//       cin >> confirm;
//       if(confirm!='y') {
//         printf("Renew aborted. Bye.\n\n");
//         exit(0);
//       }
//     }
//     if(all) {
//       vector<string> empty;
//       logger_instance->log(log4cpp::Priority::INFO, string("Renew-ing all jobs on [")+serviceAddress+"]...", true, WRITE_LOG_ON_FILE, true);
//       initSoap->renewProxy(DID, serviceAddress, certfile, empty );
//     }
    //else {
      for(map<string, vector<string> >::iterator it=url_jobids.begin(); it!=url_jobids.end(); it++) {
	if(debug)
	  logger_instance->log(log4cpp::Priority::INFO, string("Renew-ing selected jobs on [")+(*it).first+"Delegation]...", true, WRITE_LOG_ON_FILE, true);
	initSoap->renewProxy(DID, (*it).first, (*it).first+"Delegation", certfile, (*it).second);
	log_dev->notice( "Proxy renewal request succesfully sent to CREAM service at [%s]", (*it).first.c_str());
      }
    //}
  } catch(exception& s) {
    logger_instance->log(log4cpp::Priority::ERROR, s.what(), true, WRITE_LOG_ON_FILE, true );
    exit(1);
  }
*/
  return 0;
}

void printhelp() {
  printf("%s\n",help_messages::getRenewHelp().c_str());
}
